import room, foe, data, thing

class dungeon:
  def __init__(self, name):
    self.name = name
    self.loaddata()
    self.startup()
  def loaddata(self):
    f = data.load("dungeon", self.name + ".dat")
    lines = [line[0:-1] for line in f]
    self.room0, self.e0 = [int(a) for a in lines[0].split(" ")]
    self.roomdata = []
    for line in lines[1:]:
      d = line.split(" ")
      if len(d) < 9: continue
      rname = d[0]
      rdialog = int(d[1])
      rexits = [(int(d[j]), int(d[j+1])) for j in (2, 4, 6, 8)]
      rfoes = d[10:]
      self.roomdata.append([rname, rdialog, rexits, rfoes])
  def startup(self):
    self.currentroomn, self.e = self.room0, self.e0
    try:
      f = data.load("savegame.dat")
      for line in f:
        if not "|" in line: continue
        dname, r, e = line[:-1].split("|")
        if dname == self.name:
          self.currentroomn, self.e = int(r), int(e)
    except IOError:
      pass
    self.loadroom()
  def getdialog(self):
    d = self.roomdata[self.currentroomn][1]
    self.roomdata[self.currentroomn][1] = -1
    return d
  def issave(self):
    return self.roomdata[self.currentroomn][0] == "start"
  def loadroom(self):
    name, dialog, exits, foes = self.roomdata[self.currentroomn]
    if self.issave():  # Save point
      try:
        f = data.load("savegame.dat")
        lines = [line for line in f.readlines() if self.name not in line]
        f.close()
      except IOError:
        lines = []
      lines.append("%s|%d|%d\n" % (self.name, self.currentroomn, self.e))
      f = data.load("savegame.dat", None, "w")
      for line in lines: f.write(line)
      f.close()

    self.room = room.Room(name)
    self.foe = []
    for j in range(len(foes)):
      p = self.room.patrol[j]
      if foes[j] == "s":
        s = foe.scorp(p[0])
        s.setpatrol(p)
        self.foe.append(s)        
      if foes[j] == "b":
        s = foe.boar(p[0])
        s.setpatrol(p)
        self.foe.append(s)
      if foes[j] == "m":
        s = foe.mine(p[0])
        s.setpatrol(p)
        self.foe.append(s)
    if self.currentroomn + 1 == len(self.roomdata):
      self.foe.append(thing.larry(self.room.entrance[1]))
    self.entrance = self.room.entrance[self.e]
  def win(self):
    return self.currentroomn + 1 == len(self.roomdata) and not self.foe
  def exitroom(self, direction):
    exits = self.roomdata[self.currentroomn][2]
    self.currentroomn, self.e = exits[direction]
    if self.currentroomn >= 0: self.loadroom()


