# Main game loopage

import pygame, data, screen, room, thing, spell, foe, dungeon, worldmap, dialog
from pygame import *
from thing import *
from spell import *
from foe import *

def main():
  init()
  scr = screen.Screen((800, 500), False)
  talky = dialog.dialog()
  clock = time.Clock()
  quitting = False
  while not quitting:
    # Level select!
#    choice = worldmap.choose(scr)

    playing = True
    dun = dungeon.dungeon("dungeon")
    you = wizard(dun.entrance)
    weapons = (fspell, dspell, hspell, ospell)
    for stype in weapons:
      if not stype.frame:
        stype.loadimages()
    jweap = 0
    while playing and not quitting and you.alive:
      r = dun.room
      scr.setwallpaper(r.img)
      projs = []
      you.setpos(dun.entrance)
      if dun.issave(): you.hp = you.hp0


      # Transition into screen
      cover = surface.Surface((scr.x, scr.y)).convert_alpha()
      cticker = 0.5

      # Main screen action
      acting = True
      ofps = 0
      trac = None
      you.pursuit = None
      while acting:
        clock.tick(60)
        fps = clock.get_fps()
        if fps != ofps:
          ofps = fps
          print fps
        dt = clock.get_time() / 1000.
        e = event.get()
        kdowns = [x.key for x in e if x.type == KEYDOWN]
        if K_ESCAPE in kdowns: exit()
        if K_TAB in kdowns: jweap = (jweap + 1) % len(weapons)
        for x in e:
          if x.type == MOUSEBUTTONDOWN:
            if x.button == 1 and you.cancast():
              p = you.casttoward(scr.tpos(x.pos), r, weapons[jweap])
              projs.append(p)
            if x.button == 3:
              you.setpursuit(scr.tpos(x.pos))
        kpress = key.get_pressed()
        if you.tracer:
          t = you.trajtoward(scr.tpos(mouse.get_pos()), 300)
          trac = tracer(t, r.walls, you.tracer)

        dwalk = dt * you.v
        upkeys = (K_UP, K_COMMA, K_w)
        downkeys = (K_DOWN, K_o, K_s)
        leftkeys = (K_LEFT, K_a)
        rightkeys = (K_RIGHT, K_e, K_d)
        wx, wy = 0, 0
        if any(kpress[k] for k in leftkeys): wx -= 1
        if any(kpress[k] for k in rightkeys): wx += 1
        if any(kpress[k] for k in upkeys): wy -= 1
        if any(kpress[k] for k in downkeys): wy += 1
        if wx or wy:
          if wx and wy: wx, wy = wx / sqrt(2), wy / sqrt(2)
          if not you.tsleep:
            you.shift((dwalk * wx, dwalk * wy))
          you.pursuit = False

	if you.humming: dt /= 3
        you.update(dt)
        if not scr.onscreen(you.pos, you.r):
          acting = False
        r.constrain(you)

        for p in projs: p.update(dt)
        todel = []
        for j in range(len(projs)):
          ok = True
          if projs[j].age > 10.: ok = False
          if not scr.onscreen(projs[j].pos): ok = False
          if collide(projs[j], you):
            ok = False
            projs[j].afflict(you)
          for f in dun.foe:
            if collide(projs[j], f):
              ok = False
              projs[j].afflict(f)
          if not ok: todel.append(j)
        for j in reversed(todel):
           del projs[j]
        for j in reversed(range(len(dun.foe))):
          dun.foe[j].update(dt, you, r)
          if dun.foe[j].cancast() and dun.foe[j].cansee(you.pos, r):
            p = dun.foe[j].casttoward(you.pos, r, fspell)
            projs.append(p)
          if not dun.foe[j].alive: del dun.foe[j]
        for f in dun.foe: r.constrain(f)

        if not you.alive: acting = False
        if dun.win(): acting = False

        scr.orient(you.pos)
        scr.clear()
        you.draw(scr)

        for p in projs: p.draw(scr)
        for f in dun.foe: f.draw(scr)
        for j in range(you.hp0):
          im = you.heart1 if you.hp > j else you.heart0
          scr.surf.blit(im, (16 + j*32, 16))
        if you.tracer and trac: trac.draw(scr)
        scr.surf.blit(weapons[jweap].icon, (8, 54))
        scr.surf.blit(weapons[jweap].caption, (80, 54))
        # Transition in
        if cticker:
          cticker = max(cticker - dt, 0)
          cover.fill((0, 0, 0, int(500 * cticker)))
          scr.surf.blit(cover, (0, 0))
          if not cticker:
            d = dun.getdialog()
            if d != -1: talky.hold(scr, d)
            clock.tick()
        display.flip()

      # Transition out of screen
      t = 0.5
      s = Surface(scr.surf.get_size()).convert_alpha()
      s.fill((0, 0, 0, 40) if you.alive else (255, 0, 0, 40))
      while t >= 0:
        clock.tick(40)
        t -= clock.get_time() / 1000.
        scr.surf.blit(s, (0, 0))
        display.flip()
      if not you.alive: quitting = True
      if not scr.onscreen(you.pos, you.r):
        dun.exitroom(scr.whichdir(you.pos, you.r))
      if dun.currentroomn == -1: quitting = True
      if dun.win(): quitting = True


