import pygame, data
from pygame import *
from data import *

class castle:
  lockpic = None
  def __init__(self, (ax, ay), iname, title, scr, locked = False):
    self.pos = int(scr.x * ax), int(scr.y * ay)
    self.image = data.loadimg("castles", iname + ".png")
    self.irect = self.image.get_rect()
    self.irect.center = self.pos
    self.title = title
    if not self.lockpic:
      castle.lockpic = data.loadimg("lock.png")  # Get it? Lock pic? Har.
    self.locked = locked
    if self.locked:
      self.title += " [LOCKED]"
      self.lrect = castle.lockpic.get_rect()
      self.lrect.center = self.irect.center
  def maketitle(self, font):
    self.tsurf = font.render(self.title, True, (255, 255, 255))
  def makebimage():
    self.bimage = surface.Surface(self.image.get_size()).convert_alpha()
    m = lambda x: int(255 - (255 - x) / 2)
    for x in range(self.irect.width):
      for y in range(self.irect.height):
        r, g, b, a = self.image.get_at((x, y))
        self.bimage.set_at((x, y), (m(r), m(g), m(b), a))
  def draw(self, scr):
    scr.surf.blit(self.image, self.irect)
    if self.locked:
      scr.surf.blit(self.lockpic, self.lrect)
  def drawtitle(self, scr):
    r = self.tsurf.get_rect()
    r.midbottom = scr.x / 2, scr.y - 10
    scr.surf.blit(self.tsurf, r)
  def hit(self, (px, py)):
    x0, y0 = self.irect.topleft
    x, y = px - x0, py - y0
    if not 0 <= x < self.irect.width: return False
    if not 0 <= y < self.irect.height: return False
    alpha = self.image.get_at((x, y))[3]
    return alpha > 128

def choose(scr):
  cs = []
  for line in data.load("dungeon", "worldmap.dat"):
    ws = line[0:-1].split(" ")
    if len(ws) < 3: continue
    p = float(ws[1]), float(ws[2])
    title = " ".join(ws[3:])
    cs.append(castle(p, ws[0], title, scr, True))
  font.init()
  f = font.SysFont("freeserif	", 40)
  s1 = f.render("Select", True, (255, 255, 255))
  s2 = f.render("Level", True, (255, 255, 255))
  for c in cs: c.maketitle(f)

  clock = time.Clock()
  while 1:
    clock.tick(60)
    e = event.get()
    kdowns = [x.key for x in e if x.type == KEYDOWN]
    if K_ESCAPE in kdowns: exit()
    for x in e:
      if x.type == MOUSEBUTTONDOWN:
        pass
    scr.surf.fill((0,0,255,0))
    scr.surf.blit(s1, (12, 12))
    scr.surf.blit(s2, (24, 56))
    for c in cs:
      c.draw(scr)
      if c.hit(mouse.get_pos()):
        c.drawtitle(scr)
    display.flip()




